//---------------------------------------------------------------------------
#ifndef plotmainH
#define plotmainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include "graph.h"
#include "rtklib.h"
#include <Menus.hpp>

#define MAXNFILE    32					// max number of solution files

//---------------------------------------------------------------------------
class TPlot : public TForm
{
__published:
	TPanel *Panel2;
	TLabel *Message2;
	TPanel *Panel1;
	TPanel *Panel11;
	TPanel *Panel22;
	TComboBox *PlotTypeSol;
	TScrollBar *TimeScroll;
	TComboBox *QFlag;
	TOpenDialog *OpenSolDialog;
	TSpeedButton *BtnSol1;
	TSpeedButton *BtnSol2;
	TSpeedButton *BtnSol12;
	TSpeedButton *BtnCenterOri;
	TSpeedButton *BtnFitY;
	TPaintBox *Disp;
	TLabel *Message1;
	TPanel *Panel21;
	TLabel *QL1;
	TLabel *QL2;
	TLabel *QL3;
	TLabel *QL4;
	TLabel *QL5;
	TLabel *QL6;
	TSpeedButton *BtnFitX;
	TComboBox *ObsType;
	TComboBox *PlotTypeObs;
	TSpeedButton *BtnCenterTrack;
	TComboBox *DopType;
	TSpeedButton *BtnReload;
	TSpeedButton *BtnShowTrack;
	TSpeedButton *BtnOn1;
	TSpeedButton *BtnOn2;
	TSpeedButton *BtnOn3;
	TMainMenu *MainMenu;
	TMenuItem *File1;
	TMenuItem *MenuOpenSol1;
	TMenuItem *MenuOpenSol2;
	TMenuItem *N1;
	TMenuItem *MenuReload;
	TMenuItem *MenuClose;
	TMenuItem *N2;
	TMenuItem *MenuQuit;
	TMenuItem *View1;
	TMenuItem *MenuOpenObs;
	TOpenDialog *OpenObsDialog;
	TMenuItem *MenuCenterOri;
	TMenuItem *MenuFitX;
	TMenuItem *MenuFitY;
	TMenuItem *N3;
	TMenuItem *MenuShowTrack;
	TMenuItem *MenuCenterTrack;
	TMenuItem *Help1;
	TMenuItem *MenuAbout;
	TMenuItem *Edit1;
	TMenuItem *MenuOptions;
	TMenuItem *MenuTime;
	TMenuItem *N4;
	TMenuItem *N5;
	TSpeedButton *BtnAnimate;
	TTimer *Timer;
	TMenuItem *MenuAnimStart;
	TMenuItem *N6;
	TMenuItem *MenuAnimStop;
	TMenuItem *MenuToolBar;
	TMenuItem *MenuStatusBar;
	TMenuItem *N7;
	TMenuItem *OpenNavData;
	TMenuItem *MenuElevMask;
	TOpenDialog *OpenElMaskDialog;
	TMenuItem *N8;
	TMenuItem *MenyCopy;
	TComboBox *SatList1;
	TComboBox *SatList2;
	void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall PlotTypeSolChange(TObject *Sender);
	void __fastcall DispMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall DispMouseLeave(TObject *Sender);
	void __fastcall DispMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall DispMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall TimeScrollChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall QFlagChange(TObject *Sender);
	void __fastcall BtnSol1Click(TObject *Sender);
	void __fastcall BtnSol2Click(TObject *Sender);
	void __fastcall BtnFitYClick(TObject *Sender);
	void __fastcall BtnCenterOriClick(TObject *Sender);
	void __fastcall BtnSol12Click(TObject *Sender);
	void __fastcall DispPaint(TObject *Sender);
	void __fastcall BtnFitXClick(TObject *Sender);
	void __fastcall ObsTypeChange(TObject *Sender);
	void __fastcall PlotTypeObsChange(TObject *Sender);
	void __fastcall BtnCenterTrackClick(TObject *Sender);
	void __fastcall DopTypeChange(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall BtnShowTrackClick(TObject *Sender);
	void __fastcall BtnOn1Click(TObject *Sender);
	void __fastcall BtnOn2Click(TObject *Sender);
	void __fastcall BtnOn3Click(TObject *Sender);
	void __fastcall MenuOpenSol1Click(TObject *Sender);
	void __fastcall MenuOpenSol2Click(TObject *Sender);
	void __fastcall MenuOpenObsClick(TObject *Sender);
	void __fastcall MenuOpenNavClick(TObject *Sender);
	void __fastcall MenuReloadClick(TObject *Sender);
	void __fastcall MenuCloseClick(TObject *Sender);
	void __fastcall MenuQuitClick(TObject *Sender);
	void __fastcall MenuOptionsClick(TObject *Sender);
	void __fastcall MenuTimeClick(TObject *Sender);
	void __fastcall MenuAboutClick(TObject *Sender);
	void __fastcall MenuShowTrackClick(TObject *Sender);
	void __fastcall MenuCenterTrackClick(TObject *Sender);
	void __fastcall MenuCenterOriClick(TObject *Sender);
	void __fastcall MenuFitXClick(TObject *Sender);
	void __fastcall MenuFitYClick(TObject *Sender);
	void __fastcall BtnReloadClick(TObject *Sender);
	void __fastcall MenuSatClick(TObject *Sender);
	void __fastcall BtnSol1DblClick(TObject *Sender);
	void __fastcall BtnSol2DblClick(TObject *Sender);
	void __fastcall TimerTimer(TObject *Sender);
	void __fastcall MenuAnimStartClick(TObject *Sender);
	void __fastcall MenuAnimStopClick(TObject *Sender);
	void __fastcall BtnAnimateClick(TObject *Sender);
	void __fastcall MenuToolBarClick(TObject *Sender);
	void __fastcall MenuStatusBarClick(TObject *Sender);
	void __fastcall UpdateSatMask(void);
	void __fastcall MenuElevMaskClick(TObject *Sender);
	void __fastcall MenyCopyClick(TObject *Sender);
	void __fastcall SatList1Change(TObject *Sender);
private:
	solp_t Sol[2];
	obs_t Obs;
	nav_t Nav;
	solstat_t SolStat[2];
	
	Graphics::TBitmap *Buff;
	TGraph *GraphT,*GraphG[3],*GraphR,*GraphS;
	TStrings *SolFiles[2],*ObsFiles,*NavFiles;
	int Drag,Xn,Yn,NRPos[2],NObs,*IndexObs;
	int Week,DispUpdate,PlotType,PosType;
	int NSolF1,NSolF2,NObsF,NNavF;
	int SatMask[MAXSAT];
	double X0,Y0,Xc,Yc,Xs,Ys,OPos[3],RPos[2][10][3],*Az,*El;
	double ElMaskData[361];
	
	void __fastcall DropFiles(TWMDropFiles msg); // for files drop
	void __fastcall ReadElMaskData(AnsiString file);
	int __fastcall CheckObs(AnsiString file);
	void __fastcall ClearRaw(void);
	void __fastcall UpdateAzEl(void);
	void __fastcall ClearData(void);
	void __fastcall Reload(void);
	void __fastcall Refresh(void);
	void __fastcall Redraw(void);
	
	void __fastcall DrawSolTrk(int level);
	void __fastcall DrawSolTrkD(int level);
	void __fastcall DrawErrCirc(double *x, double *y, double *z,
		double *xs, double *ys, double *xys, int m, int style);
	void __fastcall DrawStatTrk(double *x, double *y, double *z, int m, int p);
	void __fastcall DrawSolPos(int level);
	void __fastcall DrawSolPosD(int level);
	void __fastcall DrawSolPosP(gtime_t *t, double *x, double *y,
		double *z, int *q, double *xs, double *ys, double *zs, int m, int level,
		int style);
	void __fastcall DrawStatPos(double *x, double *y, double *z, int m,
		AnsiString unit, int p);
	void __fastcall DrawSolNs(int level);
	void __fastcall DrawSolRes(int level, int frq);
	
	void __fastcall DrawObsRaw(int level);
	void __fastcall DrawObsSky(int level);
	void __fastcall DrawObsDop(int level);
	void __fastcall DrawSlip(double *yp);
	void __fastcall DrawEphs(double *yp);
	void __fastcall DrawStatDop(double *dop, int *ns, int n);
	
	void __fastcall UpdateOpt(void);
	void __fastcall UpdateColor(void);
	void __fastcall UpdateSize(void);
	void __fastcall UpdateSelect(void);
	void __fastcall UpdateTime(void);
	void __fastcall UpdateInfo(void);
	void __fastcall UpdatePoint(int x, int y);
	void __fastcall UpdateOrigin(void);
	void __fastcall UpdateLimTime(int all);
	void __fastcall UpdateLimFit(int all);
	void __fastcall UpdateLimOri(int all);
	void __fastcall UpdateEnable(void);
	void __fastcall GetTimeSpan(gtime_t *ts, gtime_t *te, double *tint);
	int __fastcall SearchPos(int x, int y);
	int __fastcall ObsColor(const obsd_t *obs, double az, double el);
	int __fastcall SolToXyz(const solpd_t *data, int n, gtime_t *t,
		double *x, double *y, double *z, int *q, double *xs, double *ys,
		double *zs, double *xys, int qflag, int type);
	int __fastcall SolDiff(gtime_t *time, double *x, double *y,
		double *z, int *q, int n);
	double __fastcall SolToVel(gtime_t time1, gtime_t time0,
		const double *pos1, const double *pos0, double &dir);
	void __fastcall DrawArrow(const gtime_t *t, const double *x,
		const double *y, int n);
	void __fastcall CalcStats(const double *x, int n, double ref, double &ave,
		double &std, double &rms);
	double __fastcall TimePos(gtime_t time);
	AnsiString __fastcall TimeStr(gtime_t time, int n, int tsys);
	int __fastcall ScreenTime(gtime_t time);
	void __fastcall ShowMsg(AnsiString msg);
	void __fastcall ShowLegend(AnsiString *msgs);
	void __fastcall LoadOpt(void);
	void __fastcall SaveOpt(void);
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES,TWMDropFiles,DropFiles);
	END_MESSAGE_MAP(TForm);
public:
	// options 
	int TimeEna[3],ObsFormat,TimeLabel,AutoScale;
	int ShowStats,ShowLabel,ShowGLabel,ShowScale,ShowCompass;
	int ShowArrow,ShowSlip,ShowErr,ShowEph,ShowHalfC;
	int PlotStyle,MarkSize,Origin,AnimCycle,HideLowSat,ElMaskP;
	int RawObs,NavSys;
	AnsiString ExSats;
	gtime_t TimeStart,TimeEnd;
	double TimeInt,ElMask,MaxDop,YRange,OOPos[3];
	TColor MColor[7],CColor[4];
	
	__fastcall TPlot(TComponent* Owner);
	int __fastcall ReadSol(TStrings *files, int sel);
	int __fastcall ReadObs(TStrings *files);
	int __fastcall ReadNav(TStrings *files);
};
//---------------------------------------------------------------------------
extern PACKAGE TPlot *Plot;
//---------------------------------------------------------------------------
#endif
